/*
  INF3105 - Structures de données et algorithmes
  Lab8 - Historique de températures
*/

#include "arbremap.h"

#include <fstream>
#include <iostream>

class Historique {
 public:
  void ajouter(float date, float temp);
  float estimerTemperature(float date) const;
  float calculerMoyenne(float debut, float fin) const;

 private:
  // Représentation

};

int main(int argc, char* argv[]) {
  if (argc < 2) {
    std::cerr << "./lab6_4B fichier.txt" << std::endl;
    return 1;
  }

  std::ifstream in(argv[1]);
  Historique h;
  while (in) {
    float d, t;
    in >> d >> t;
    if (in) h.ajouter(d, t);
  }

  while (std::cin) {
    float d1, d2;
    std::cin >> d1 >> d2;
    if (std::cin) {
      float t1 = h.estimerTemperature(d1);
      float t2 = h.estimerTemperature(d2);
      float moy = h.calculerMoyenne(d1, d2);
      std::cout << "t1 = " << t1 << '\t' << "t2 = " << t2 << '\t'
                << "moy = " << moy << std::endl;
    }
  }

  return 0;
}

void Historique::ajouter(float date, float temp) {
  // À compléter
}

float Historique::estimerTemperature(float date) const {
  // À compléter
  return 0.0f;
}

float Historique::calculerMoyenne(float debut, float fin) const {
  // À compléter
  return 0.0f;
}
